//#line 2 "/opt/ros/indigo/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
//
// File autogenerated for the dynamic_transform_publisher package
// by the dynamic_reconfigure package.
// Please do not edit.
//
// ********************************************************/

#ifndef __dynamic_transform_publisher__TFCONFIG_H__
#define __dynamic_transform_publisher__TFCONFIG_H__

#if __cplusplus >= 201103L
#define DYNAMIC_RECONFIGURE_FINAL final
#else
#define DYNAMIC_RECONFIGURE_FINAL
#endif

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace dynamic_transform_publisher
{
  class TFConfigStatics;

  class TFConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l,
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }

      virtual void clamp(TFConfig &config, const TFConfig &max, const TFConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const TFConfig &config1, const TFConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, TFConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const TFConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, TFConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const TFConfig &config) const = 0;
      virtual void getValue(const TFConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template <class T>
    class ParamDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string a_name, std::string a_type, uint32_t a_level,
          std::string a_description, std::string a_edit_method, T TFConfig::* a_f) :
        AbstractParamDescription(a_name, a_type, a_level, a_description, a_edit_method),
        field(a_f)
      {}

      T (TFConfig::* field);

      virtual void clamp(TFConfig &config, const TFConfig &max, const TFConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;

        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const TFConfig &config1, const TFConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, TFConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const TFConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, TFConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const TFConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const TFConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, TFConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template<class T, class PT>
    class GroupDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string a_name, std::string a_type, int a_parent, int a_id, bool a_s, T PT::* a_f) : AbstractGroupDescription(a_name, a_type, a_parent, a_id, a_s), field(a_f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, TFConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<TFConfig::AbstractGroupDescriptionConstPtr> groups;
    };

class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(TFConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("frame_id"==(*_i)->name){frame_id = boost::any_cast<std::string>(val);}
        if("child_frame_id"==(*_i)->name){child_frame_id = boost::any_cast<std::string>(val);}
        if("period"==(*_i)->name){period = boost::any_cast<double>(val);}
        if("x"==(*_i)->name){x = boost::any_cast<double>(val);}
        if("y"==(*_i)->name){y = boost::any_cast<double>(val);}
        if("z"==(*_i)->name){z = boost::any_cast<double>(val);}
        if("use_rpy"==(*_i)->name){use_rpy = boost::any_cast<bool>(val);}
      }
    }

    std::string frame_id;
std::string child_frame_id;
double period;
double x;
double y;
double z;
bool use_rpy;

    bool state;
    std::string name;

    class RPY
{
  public:
    RPY()
    {
      state = true;
      name = "RPY";
    }

    void setParams(TFConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("roll"==(*_i)->name){roll = boost::any_cast<double>(val);}
        if("pitch"==(*_i)->name){pitch = boost::any_cast<double>(val);}
        if("yaw"==(*_i)->name){yaw = boost::any_cast<double>(val);}
      }
    }

    double roll;
double pitch;
double yaw;

    bool state;
    std::string name;

    
}rpy;

class QUATERNION
{
  public:
    QUATERNION()
    {
      state = true;
      name = "Quaternion";
    }

    void setParams(TFConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("qx"==(*_i)->name){qx = boost::any_cast<double>(val);}
        if("qy"==(*_i)->name){qy = boost::any_cast<double>(val);}
        if("qz"==(*_i)->name){qz = boost::any_cast<double>(val);}
        if("qw"==(*_i)->name){qw = boost::any_cast<double>(val);}
      }
    }

    double qx;
double qy;
double qz;
double qw;

    bool state;
    std::string name;

    
}quaternion;

}groups;



//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string frame_id;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string child_frame_id;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double period;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double x;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double y;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double z;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool use_rpy;
//#line 16 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      double roll;
//#line 17 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      double pitch;
//#line 18 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      double yaw;
//#line 20 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      double qx;
//#line 21 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      double qy;
//#line 22 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      double qz;
//#line 23 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      double qw;
//#line 228 "/opt/ros/indigo/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("TFConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }

    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }

    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const TFConfig &__max__ = __getMax__();
      const TFConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const TFConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }

    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const TFConfig &__getDefault__();
    static const TFConfig &__getMax__();
    static const TFConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();

  private:
    static const TFConfigStatics *__get_statics__();
  };

  template <> // Max and min are ignored for strings.
  inline void TFConfig::ParamDescription<std::string>::clamp(TFConfig &config, const TFConfig &max, const TFConfig &min) const
  {
    (void) config;
    (void) min;
    (void) max;
    return;
  }

  class TFConfigStatics
  {
    friend class TFConfig;

    TFConfigStatics()
    {
TFConfig::GroupDescription<TFConfig::DEFAULT, TFConfig> Default("Default", "", 0, 0, true, &TFConfig::groups);
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.frame_id = "";
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.frame_id = "";
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.frame_id = "";
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<std::string>("frame_id", "str", 0, "The name of the frame to reference", "", &TFConfig::frame_id)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<std::string>("frame_id", "str", 0, "The name of the frame to reference", "", &TFConfig::frame_id)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.child_frame_id = "";
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.child_frame_id = "";
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.child_frame_id = "";
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<std::string>("child_frame_id", "str", 0, "The name of the frame to broadcast", "", &TFConfig::child_frame_id)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<std::string>("child_frame_id", "str", 0, "The name of the frame to broadcast", "", &TFConfig::child_frame_id)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.period = 0.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.period = 1000.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.period = 100.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("period", "double", 0, "period (in ms)", "", &TFConfig::period)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("period", "double", 0, "period (in ms)", "", &TFConfig::period)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.x = -100.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.x = 100.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.x = 0.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("x", "double", 0, "x", "", &TFConfig::x)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("x", "double", 0, "x", "", &TFConfig::x)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.y = -100.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.y = 100.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.y = 0.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("y", "double", 0, "y", "", &TFConfig::y)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("y", "double", 0, "y", "", &TFConfig::y)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.z = -100.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.z = 100.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.z = 0.0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("z", "double", 0, "z", "", &TFConfig::z)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("z", "double", 0, "z", "", &TFConfig::z)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.use_rpy = 0;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.use_rpy = 1;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.use_rpy = 1;
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<bool>("use_rpy", "bool", 0, "Use RPY values", "", &TFConfig::use_rpy)));
//#line 290 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<bool>("use_rpy", "bool", 0, "Use RPY values", "", &TFConfig::use_rpy)));
TFConfig::GroupDescription<TFConfig::DEFAULT::RPY, TFConfig::DEFAULT> RPY("RPY", "", 0, 1, true, &TFConfig::DEFAULT::rpy);
//#line 16 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __min__.roll = -3.14;
//#line 16 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __max__.roll = 3.14;
//#line 16 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __default__.roll = 0.0;
//#line 16 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      RPY.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("roll", "double", 0, "roll", "", &TFConfig::roll)));
//#line 16 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("roll", "double", 0, "roll", "", &TFConfig::roll)));
//#line 17 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __min__.pitch = -3.14;
//#line 17 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __max__.pitch = 3.14;
//#line 17 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __default__.pitch = 0.0;
//#line 17 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      RPY.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("pitch", "double", 0, "pitch", "", &TFConfig::pitch)));
//#line 17 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("pitch", "double", 0, "pitch", "", &TFConfig::pitch)));
//#line 18 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __min__.yaw = -3.14;
//#line 18 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __max__.yaw = 3.14;
//#line 18 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __default__.yaw = 0.0;
//#line 18 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      RPY.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("yaw", "double", 0, "yaw", "", &TFConfig::yaw)));
//#line 18 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("yaw", "double", 0, "yaw", "", &TFConfig::yaw)));
//#line 124 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      RPY.convertParams();
//#line 124 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.groups.push_back(TFConfig::AbstractGroupDescriptionConstPtr(new TFConfig::GroupDescription<TFConfig::DEFAULT::RPY, TFConfig::DEFAULT>(RPY)));
//#line 124 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(TFConfig::AbstractGroupDescriptionConstPtr(new TFConfig::GroupDescription<TFConfig::DEFAULT::RPY, TFConfig::DEFAULT>(RPY)));
TFConfig::GroupDescription<TFConfig::DEFAULT::QUATERNION, TFConfig::DEFAULT> Quaternion("Quaternion", "", 0, 2, true, &TFConfig::DEFAULT::quaternion);
//#line 20 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __min__.qx = -1.0;
//#line 20 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __max__.qx = 1.0;
//#line 20 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __default__.qx = 0.0;
//#line 20 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      Quaternion.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("qx", "double", 0, "qx", "", &TFConfig::qx)));
//#line 20 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("qx", "double", 0, "qx", "", &TFConfig::qx)));
//#line 21 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __min__.qy = -1.0;
//#line 21 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __max__.qy = 1.0;
//#line 21 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __default__.qy = 0.0;
//#line 21 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      Quaternion.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("qy", "double", 0, "qy", "", &TFConfig::qy)));
//#line 21 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("qy", "double", 0, "qy", "", &TFConfig::qy)));
//#line 22 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __min__.qz = -1.0;
//#line 22 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __max__.qz = 1.0;
//#line 22 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __default__.qz = 0.0;
//#line 22 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      Quaternion.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("qz", "double", 0, "qz", "", &TFConfig::qz)));
//#line 22 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("qz", "double", 0, "qz", "", &TFConfig::qz)));
//#line 23 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __min__.qw = -1.0;
//#line 23 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __max__.qw = 1.0;
//#line 23 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __default__.qw = 1.0;
//#line 23 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      Quaternion.abstract_parameters.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("qw", "double", 0, "qw", "", &TFConfig::qw)));
//#line 23 "/tmp/binarydeb/ros-indigo-dynamic-transform-publisher-1.0.1/cfg/TF.cfg"
      __param_descriptions__.push_back(TFConfig::AbstractParamDescriptionConstPtr(new TFConfig::ParamDescription<double>("qw", "double", 0, "qw", "", &TFConfig::qw)));
//#line 124 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Quaternion.convertParams();
//#line 124 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.groups.push_back(TFConfig::AbstractGroupDescriptionConstPtr(new TFConfig::GroupDescription<TFConfig::DEFAULT::QUATERNION, TFConfig::DEFAULT>(Quaternion)));
//#line 124 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(TFConfig::AbstractGroupDescriptionConstPtr(new TFConfig::GroupDescription<TFConfig::DEFAULT::QUATERNION, TFConfig::DEFAULT>(Quaternion)));
//#line 245 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 245 "/opt/ros/indigo/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(TFConfig::AbstractGroupDescriptionConstPtr(new TFConfig::GroupDescription<TFConfig::DEFAULT, TFConfig>(Default)));
//#line 366 "/opt/ros/indigo/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<TFConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__);
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__);
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__);
    }
    std::vector<TFConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<TFConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    TFConfig __max__;
    TFConfig __min__;
    TFConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const TFConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static TFConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &TFConfig::__getDescriptionMessage__()
  {
    return __get_statics__()->__description_message__;
  }

  inline const TFConfig &TFConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }

  inline const TFConfig &TFConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }

  inline const TFConfig &TFConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }

  inline const std::vector<TFConfig::AbstractParamDescriptionConstPtr> &TFConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<TFConfig::AbstractGroupDescriptionConstPtr> &TFConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const TFConfigStatics *TFConfig::__get_statics__()
  {
    const static TFConfigStatics *statics;

    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = TFConfigStatics::get_instance();

    return statics;
  }


}

#undef DYNAMIC_RECONFIGURE_FINAL

#endif // __TFRECONFIGURATOR_H__
